Bug 104428 - exploded donut uses too small radius
Summary: exploded donut uses too small radius
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Chart (show other bugs)
Version:
(earliest affected)
Inherited From OOo
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: kurt.nordback@protonmail.com
URL:
Whiteboard: target:7.5.0 target:7.4.0.0.beta2
Keywords:
Depends on:
Blocks: Chart
  Show dependency treegraph
 
Reported: 2016-12-06 07:33 UTC by Martin Koller
Modified: 2022-07-05 16:26 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:
Regression By:


Attachments
exploded donut screenshot (13.48 KB, image/png)
2016-12-06 07:33 UTC, Martin Koller
Details
ods showing the bug (16.84 KB, application/vnd.oasis.opendocument.spreadsheet)
2016-12-06 16:43 UTC, Martin Koller
Details
MS Office rendering of the test case (17.29 KB, image/png)
2022-05-31 20:52 UTC, kurt.nordback@protonmail.com
Details

Note You need to log in before you can comment on or make changes to this bug.
Description Martin Koller 2016-12-06 07:33:31 UTC
Created attachment 129337 [details]
exploded donut screenshot

The exploded donut (see attached screenshot) uses a wrong calculation for the radius of the exploded slices.
As you can see it seems the radius used is the same as the outer radius of the inner ring and the exploded slices are just shifted.
My expectation of the result is that the exploded slices use a radius which orresponds to the position where it is drawn so that the exploded slice and the inner slice will never touch (the inner and the exploded slices should be on concentrical circles)
Comment 1 Xisco Faulí 2016-12-06 14:05:58 UTC
Hello Martin,

Thank you for reporting the bug. Please attach a sample document, as this makes it easier for us to verify the bug. 
I have set the bug's status to 'NEEDINFO'. Please change it back to 'UNCONFIRMED' once the requested document is provided.
(Please note that the attachment will be public, remove any sensitive information before attaching it. 
See https://wiki.documentfoundation.org/QA/FAQ#How_can_I_eliminate_confidential_data_from_a_sample_document.3F for help on how to do so.)
Comment 2 Martin Koller 2016-12-06 16:43:57 UTC
Created attachment 129353 [details]
ods showing the bug
Comment 3 Xisco Faulí 2016-12-06 21:34:23 UTC
Confirmed in

- Version: 5.4.0.0.alpha0+
Build ID: 18b3138a7ac4da823e41640bed8a4707029b8fb0
CPU Threads: 4; OS Version: Linux 4.8; UI Render: default; VCL: gtk3; 
Locale: ca-ES (ca_ES.UTF-8); Calc: group

- Version: 5.0.0.0.alpha1+
Build ID: 0db96caf0fcce09b87621c11b584a6d81cc7df86
Locale: ca-ES (ca_ES.UTF-8)

- LibreOffice 3.3.0 
OOO330m19 (Build:6)
tag libreoffice-3.3.0.4
Comment 4 QA Administrators 2017-12-08 08:08:34 UTC Comment hidden (noise, obsolete)
Comment 5 Roman Kuznetsov 2019-03-19 12:29:51 UTC
still repro in

Version: 6.3.0.0.alpha0+ (x64)
Build ID: de024e572dd7a588f82b84c68daa2051ec6b20e9
CPU threads: 4; OS: Windows 10.0; UI render: GL; VCL: win; 
TinderBox: Win-x86_64@42, Branch:master, Time: 2019-03-18_01:13:57
Locale: ru-RU (ru_RU); UI-Language: en-US
Calc: threaded
Comment 6 QA Administrators 2021-03-19 04:40:39 UTC Comment hidden (noise)
Comment 7 Martin Koller 2022-02-12 12:01:24 UTC
Still valid for version
Version: 7.2.5.1 / LibreOffice Community
Build ID: 20(Build:1)
CPU threads: 4; OS: Linux 5.16; UI render: default; VCL: kf5 (cairo+xcb)
Locale: de-AT (de_AT.UTF-8); UI: en-US
Calc: threaded
Comment 8 kurt.nordback@protonmail.com 2022-05-31 20:52:15 UTC
Created attachment 180509 [details]
MS Office rendering of the test case

It's not clear exactly what behavior is being requested here. This image shows the MS Office rendering the analogous test case. The basic behavior is the same as that of LO (other than a difference in angular convention, which is distinct from the issue at hand).
Comment 9 Martin Koller 2022-06-01 06:06:45 UTC
"It's not clear exactly what behavior is being requested here."

I would expect the exploded rings to have a larger radius so that they are shown concentric to the inner ring to not touch the inner ring.

As it is now, it looks ugly
Comment 10 kurt.nordback@protonmail.com 2022-06-03 21:22:12 UTC
I've submitted a proposed fix for this on branch 104428_patch.

Here's the commit comment:

tdf#104428 Improve rendering of exploded donut charts

This bug shows an exploded donut chart with more than one series. The
concern is that the standard pie/donut' explosion' rendering, with the shape
of the pieces unchanged but the pieces translated outward, gives
unsatisfactory results in the case of a donut with more than one series,
where the translated 'exploded' pieces can overlap with the inner ring.
This proposed fix renders this case differently, by increasing the radius
of the exploded ring but keeping the pieces concentric with the inner ring."
Comment 11 Martin Koller 2022-06-06 14:53:37 UTC
Why was this assigned to me ? What am I supposed to do now ?
Comment 12 kurt.nordback@protonmail.com 2022-06-06 15:04:16 UTC
I don't know the accepted LO process. I assumed that assigning to the original reporter to verify the fix was the right thing.
Comment 13 Commit Notification 2022-07-05 09:54:00 UTC
Kurt Nordback committed a patch related to this issue.
It has been pushed to "master":

https://git.libreoffice.org/core/commit/9b558357a3e7a4c908084134d56770809116b4f1

tdf#104428 Improve rendering of exploded donut charts

It will be available in 7.5.0.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.
Comment 14 Commit Notification 2022-07-05 16:26:27 UTC
Kurt Nordback committed a patch related to this issue.
It has been pushed to "libreoffice-7-4":

https://git.libreoffice.org/core/commit/597bc417192fd9eac58c3cca9527ce5646d9972f

tdf#104428 Improve rendering of exploded donut charts

It will be available in 7.4.0.0.beta2.

The patch should be included in the daily builds available at
https://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
https://wiki.documentfoundation.org/Testing_Daily_Builds

Affected users are encouraged to test the fix and report feedback.